#!/usr/bin/perl

use strict;
use warnings;

use DBI;
use Time::HiRes qw(gettimeofday tv_interval);

my $dbh = DBI->connect('dbi:mysql:database=test', 'root', '');

my $try = 1000;

foreach my $i (qw(groups_t groups_d groups_dt groups_td)) {
    my $query = "SELECT SQL_NO_CACHE STRAIGHT_JOIN DISTINCT g.id\n"
        ."\tFROM acl a, groups g USE INDEX($i)\n"
        ."\tWHERE (g.domain = 'queue' OR g.domain = 'system') AND g.type = a.type\n";
    print $query;
    my $time = bench($dbh, $query, $try);
    print "time: $time\n";
}

sub bench {
    my ($dbh, $query, $tries) = @_;

    my $t0 = [gettimeofday];
    while ( $tries-- ) {
        my $ary_ref = $dbh->selectall_arrayref($query);
    }
    return tv_interval ( $t0 );
}
